module ZXFile
	class BasicFile
	
		attr_accessor :program_data, :variables_data, :start_line, :name

		def initialize(opts = {})
			if opts[:program_data]
				@program_data = opts[:program_data]
			elsif opts[:program]
				@program_data = ZXFile::BasicBuilder.build(opts[:program])
			else
				@program_data = ''
			end
			@variables_data = opts[:variables_data] || ''
			@start_line = opts[:start_line]
			@name = opts[:name]
		end
		
		def tape_subblocks
			@tape_subblocks ||= [
				ZXFile::Tape::BasicFileHeader.new(
					:name => @name, :program_length => @program_data.size,
					:length => @program_data.size + @variables_data.size,
					:start_line => @start_line
				),
				ZXFile::Tape::RomTapeBlock.new(:data => @program_data + @variables_data)
			]
		end
		
		def write(format, file)
			ZXFile::TapeFile.write(format, file) do |io|
				tape_subblocks.each { |block| block.write(format, io) }
			end
		end
	end
end
