module ZXFile
	class CodeFile
	
		attr_accessor :data, :start_address, :name

		def initialize(opts = {})
			@data = opts[:data]
			@start_address = opts[:start_address]
			@name = opts[:name]
		end
		
		def tape_subblocks
			@tape_subblocks ||= [
				ZXFile::Tape::CodeFileHeader.new(
					:name => @name, :start_address => @start_address, :length => @data.size
				),
				ZXFile::Tape::RomTapeBlock.new(:data => @data)
			]
		end
		
		def write(format, file)
			ZXFile::TapeFile.write(format, file) do |io|
				tape_subblocks.each { |block| block.write(format, io) }
			end
		end
	end
end
