module ZXFile
	module TapeFile
		def self.write(format, file, &block)
			case format
				when :tap then ZXFile::TAPFile.write(file, &block)
				when :tzx then ZXFile::TZXFile.write(file, &block)
				else raise "Unknown file format"
			end
		end
	end

	module TAPFile
		def self.write(file)
			if file.is_a?(String)
				File.open(file, 'wb') do |io|
					yield io
				end
			else
				yield file
			end
		end
	end

	module TZXFile
		def self.write(file)
			if file.is_a?(String)
				File.open(file, 'wb') do |io|
					io.write("ZXTape!\x1a\x01\x0d")
					yield io
				end
			else
				yield file
			end
		end
	end
end
