require 'zxfile'
require 'ayfile'

module ZXTracker
	class SoundtrackerModule
		def self.open(filename)
			self.new( :data => (File.open(filename, 'rb') {|f| f.read}),
				:name => File.basename(filename) )
		end
		
		def self.player
			@@player ||= File.open(
				File.join(File.dirname(__FILE__), 'stc_player.bin'), 'rb') {|f| f.read}

		end
		
		attr_accessor :data, :name
		def initialize(opts = {})
			@data = opts[:data]
			@name = opts[:name]
		end
		
		def data_with_player
			ZXTracker::SoundtrackerModule.player + @data
		end
		
		def write(format, file)
			if format == :ay
				ayfile = AYFile.new(:misc => 'created by tracker2ay', :songs => [
					AYFile::Song.new(:name => (self.name || '(unknown)'),
						:stack => 0xbfff, :init => 0xc000, :inter => 0xc006,
						:blocks => [
							AYFile::MemoryBlock.new(0xc000, data_with_player)
						])
					])
				ayfile.write(file)
			else
				tape = ZXFile::Medium.new
				tape << ZXFile::BasicFile.new(
					:name => 'stc_player',
					:start_line => 10,
					:program => {
						10 => [:clear, 0xbfff],
						20 => [:load, '"stc_data"', :code],
						30 => [:randomize, :usr, 0xc000],
						40 => [:pause, 1, ':', :randomize, :usr, 0xc006, ':', :goto, 40]
				})
				tape << ZXFile::CodeFile.new(
					:name => 'stc_data',
					:start_address => 0xc000,
					:data => data_with_player)
				tape.write(format, file)
			end
		end
	end
end
